﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Collections.Generic;

namespace SerialAssistant
{
    public partial class Graph : Form
    {





        private int X_minimum;

        private int X_maximum = 100;

        private int X_interval = 4;

        private int Y_minimum;

        private int Y_maximum = 256;

        private int Y_interval = 16;

        private Queue<double> dataQueue1 = new Queue<double>();

        private Queue<double> dataQueue2 = new Queue<double>();

        private int nFlag;

        private IContainer components;

        private Chart chart1;

        private RadioButton rb_PolyLine;

        private RadioButton rb_WaveLine;

        private GroupBox groupBox1;

        private RadioButton rb_PointLine;

        private GroupBox groupBox2;

        private Label label6;

        private Label label5;

        private Label label4;

        private Label label3;

        private Label label2;

        private Label label1;

        private TextBox tb_Y_interval;

        private TextBox tb_Y_maximum;

        private TextBox tb_Y_minimum;

        private TextBox tb_X_interval;

        private TextBox tb_X_maximum;

        private TextBox tb_X_minimum;

        private Button bt_Redefine;

        private RadioButton rb_ColumnLine;

        private Label label7;

        private PictureBox pb_draw_status;

        public event DisplayUpdate ShowUpdate;

        public Graph()
        {
            InitializeComponent();
        }

        private void Graph_Load(object sender, EventArgs e)
        {
            this.tb_X_minimum.Text = this.X_minimum.ToString();
            this.tb_X_maximum.Text = this.X_maximum.ToString();
            this.tb_X_interval.Text = this.X_interval.ToString();
            this.tb_Y_minimum.Text = this.Y_minimum.ToString();
            this.tb_Y_maximum.Text = this.Y_maximum.ToString();
            this.tb_Y_interval.Text = this.Y_interval.ToString();
            this.nFlag = 1;
            this.InitChart();
            this.rb_PolyLine.Checked = true;
            if (this.nFlag == 1)
            {
                this.chart1.Series[0].Points.AddXY(0.0, 0.0);
                return;
            }
            this.chart1.Series[0].Points.AddXY(0.0, 0.0);
            this.chart1.Series[1].Points.AddXY(0.0, 0.0);
        }




            public void AddData(byte[] Data)
            {
                try
                {
                    int i = 0;
                    while (i < Data.Length)
                    {
                        int num = (this.X_maximum - this.X_minimum) / 2;
                        if (this.dataQueue1.Count > num)
                        {
                            this.dataQueue1.Dequeue();
                        }
                        if (this.nFlag == 1)
                        {
                            this.dataQueue1.Enqueue((double)Data[i]);
                            i++;
                        }
                        else
                        {
                            this.dataQueue1.Enqueue((double)Data[i]);
                            this.dataQueue2.Enqueue((double)Data[i + 1]);
                            i += 2;
                        }
                    }
                    if (this.pb_draw_status.BackColor == Color.Gray)
                    {
                        this.pb_draw_status.BackColor = Color.Gold;
                    }
                    else
                    {
                        this.pb_draw_status.BackColor = Color.Gray;
                    }
                    if (this.nFlag == 1)
                    {
                        this.chart1.Series[0].Points.Clear();
                        for (int j = 0; j < this.dataQueue1.Count; j++)
                        {
                            this.chart1.Series[0].Points.AddXY((double)(j * 2), this.dataQueue1.ElementAt(j));
                        }
                    }
                    else
                    {
                        this.chart1.Series[0].Points.Clear();
                        this.chart1.Series[1].Points.Clear();
                        for (int k = 0; k < this.dataQueue1.Count; k++)
                        {
                            this.chart1.Series[0].Points.AddXY((double)(k * 2), this.dataQueue1.ElementAt(k));
                            this.chart1.Series[1].Points.AddXY((double)(k * 2), this.dataQueue2.ElementAt(k));
                        }
                    }
                }
                catch
                {
                }
            }

            private void InitChart()
            {
                this.chart1.ChartAreas.Clear();
                ChartArea item = new ChartArea("C1");
                this.chart1.ChartAreas.Add(item);
                this.chart1.Series.Clear();
                if (this.nFlag == 1)
                {
                    Series series = new Series("S1");
                    series.ChartArea = "C1";
                    this.chart1.Series.Add(series);
                }
                else
                {
                    Series series2 = new Series("S1");
                    Series item2 = new Series("S2");
                    series2.ChartArea = "C1";
                    series2.ChartArea = "C1";
                    this.chart1.Series.Add(series2);
                    this.chart1.Series.Add(item2);
                }
                this.chart1.ChartAreas[0].AxisY.Minimum = (double)this.Y_minimum;
                this.chart1.ChartAreas[0].AxisY.Maximum = (double)this.Y_maximum;
                this.chart1.ChartAreas[0].AxisY.Interval = (double)this.Y_interval;
                this.chart1.ChartAreas[0].AxisX.Minimum = (double)this.X_minimum;
                this.chart1.ChartAreas[0].AxisX.Maximum = (double)this.X_maximum;
                this.chart1.ChartAreas[0].AxisX.Interval = (double)this.X_interval;
                this.chart1.ChartAreas[0].AxisX.MajorGrid.LineColor = Color.Silver;
                this.chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.Silver;
                this.chart1.Titles.Clear();
                this.chart1.Titles.Add("S01");
                this.chart1.Titles[0].Text = "数据显示";
                this.chart1.Titles[0].ForeColor = Color.RoyalBlue;
                this.chart1.Titles[0].Font = new Font("Microsoft Sans Serif", 12f);
                if (this.nFlag == 1)
                {
                    this.chart1.Series[0].Color = Color.Red;
                    this.chart1.Series[0].Points.Clear();
                    return;
                }
                this.chart1.Series[0].Color = Color.Red;
                this.chart1.Series[1].Color = Color.Green;
                this.chart1.Series[0].Points.Clear();
                this.chart1.Series[1].Points.Clear();
            }

            private void rb_PolyLine_CheckedChanged(object sender, EventArgs e)
            {
                this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_PolyLine.Text);
                if (this.nFlag == 1)
                {
                    this.chart1.Series[0].ChartType = SeriesChartType.Line;
                    return;
                }
                this.chart1.Series[0].ChartType = SeriesChartType.Line;
                this.chart1.Series[1].ChartType = SeriesChartType.Line;
            }

            private void rb_WaveLine_CheckedChanged(object sender, EventArgs e)
            {
                this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_WaveLine.Text);
                if (this.nFlag == 1)
                {
                    this.chart1.Series[0].ChartType = SeriesChartType.Spline;
                    return;
                }
                this.chart1.Series[0].ChartType = SeriesChartType.Spline;
                this.chart1.Series[1].ChartType = SeriesChartType.Spline;
            }

            private void rb_PointLine_CheckedChanged(object sender, EventArgs e)
            {
                this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_PointLine.Text);
                if (this.nFlag == 1)
                {
                    this.chart1.Series[0].ChartType = SeriesChartType.Point;
                    return;
                }
                this.chart1.Series[0].ChartType = SeriesChartType.Point;
                this.chart1.Series[1].ChartType = SeriesChartType.Point;
            }

            private void rb_ColumnLine_CheckedChanged(object sender, EventArgs e)
            {
                this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_ColumnLine.Text);
                if (this.nFlag == 1)
                {
                    this.chart1.Series[0].ChartType = SeriesChartType.Column;
                    return;
                }
                this.chart1.Series[0].ChartType = SeriesChartType.Column;
                this.chart1.Series[1].ChartType = SeriesChartType.Column;
            }

            private void Graph_FormClosing(object sender, FormClosingEventArgs e)
            {
            if (this.ShowUpdate != null)
            {
                this.ShowUpdate();
            }
        }

            private void bt_Redefine_Click(object sender, EventArgs e)
            {
                this.X_minimum = int.Parse(this.tb_X_minimum.Text);
                this.X_maximum = int.Parse(this.tb_X_maximum.Text);
                this.X_interval = int.Parse(this.tb_X_interval.Text);
                this.Y_minimum = int.Parse(this.tb_Y_minimum.Text);
                this.Y_maximum = int.Parse(this.tb_Y_maximum.Text);
                this.Y_interval = int.Parse(this.tb_Y_interval.Text);
                this.InitChart();
                if (this.rb_PolyLine.Checked)
                {
                    this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_PolyLine.Text);
                    if (this.nFlag == 1)
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Line;
                    }
                    else
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Line;
                        this.chart1.Series[1].ChartType = SeriesChartType.Line;
                    }
                }
                else if (this.rb_WaveLine.Checked)
                {
                    this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_WaveLine.Text);
                    if (this.nFlag == 1)
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Spline;
                    }
                    else
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Spline;
                        this.chart1.Series[1].ChartType = SeriesChartType.Spline;
                    }
                }
                else if (this.rb_PointLine.Checked)
                {
                    this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_PointLine.Text);
                    if (this.nFlag == 1)
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Point;
                    }
                    else
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Point;
                        this.chart1.Series[1].ChartType = SeriesChartType.Point;
                    }
                }
                else
                {
                    this.chart1.Titles[0].Text = string.Format("数据 {0} 显示", this.rb_ColumnLine.Text);
                    if (this.nFlag == 1)
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Column;
                    }
                    else
                    {
                        this.chart1.Series[0].ChartType = SeriesChartType.Column;
                        this.chart1.Series[1].ChartType = SeriesChartType.Column;
                    }
                }
                this.chart1.Series[0].Points.AddXY(0.0, 0.0);
            }

            private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
            {
                if (!char.IsNumber(e.KeyChar) && e.KeyChar != '\b')
                {
                    e.Handled = true;
                }
            }


        private void InitializeComponent()
        {
            ChartArea chartArea = new ChartArea();
            Legend legend = new Legend();
            Series series = new Series();
            this.chart1 = new Chart();
            this.rb_PolyLine = new RadioButton();
            this.rb_WaveLine = new RadioButton();
            this.groupBox1 = new GroupBox();
            this.rb_PointLine = new RadioButton();
            this.groupBox2 = new GroupBox();
            this.bt_Redefine = new Button();
            this.tb_Y_interval = new TextBox();
            this.tb_Y_maximum = new TextBox();
            this.tb_Y_minimum = new TextBox();
            this.tb_X_interval = new TextBox();
            this.tb_X_maximum = new TextBox();
            this.tb_X_minimum = new TextBox();
            this.label6 = new Label();
            this.label5 = new Label();
            this.label4 = new Label();
            this.label3 = new Label();
            this.label2 = new Label();
            this.label1 = new Label();
            this.rb_ColumnLine = new RadioButton();
            this.label7 = new Label();
            this.pb_draw_status = new PictureBox();
            ((ISupportInitialize)this.chart1).BeginInit();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((ISupportInitialize)this.pb_draw_status).BeginInit();
            base.SuspendLayout();
            this.chart1.BackColor = SystemColors.Control;
            chartArea.Name = "ChartArea1";
            this.chart1.ChartAreas.Add(chartArea);
            legend.Name = "Legend1";
            this.chart1.Legends.Add(legend);
            this.chart1.Location = new Point(2, 2);
            this.chart1.Name = "chart1";
            series.ChartArea = "ChartArea1";
            series.Legend = "Legend1";
            series.Name = "Series1";
            this.chart1.Series.Add(series);
            this.chart1.Size = new Size(990, 580);
            this.chart1.TabIndex = 0;
            this.chart1.Text = "chart1";
            this.rb_PolyLine.AutoSize = true;
            this.rb_PolyLine.Location = new Point(44, 34);
            this.rb_PolyLine.Name = "rb_PolyLine";
            this.rb_PolyLine.Size = new Size(59, 16);
            this.rb_PolyLine.TabIndex = 1;
            this.rb_PolyLine.TabStop = true;
            this.rb_PolyLine.Text = "折线图";
            this.rb_PolyLine.UseVisualStyleBackColor = true;
            this.rb_PolyLine.CheckedChanged += new EventHandler(this.rb_PolyLine_CheckedChanged);
            this.rb_WaveLine.AutoSize = true;
            this.rb_WaveLine.Location = new Point(44, 68);
            this.rb_WaveLine.Name = "rb_WaveLine";
            this.rb_WaveLine.Size = new Size(59, 16);
            this.rb_WaveLine.TabIndex = 1;
            this.rb_WaveLine.TabStop = true;
            this.rb_WaveLine.Text = "波形图";
            this.rb_WaveLine.UseVisualStyleBackColor = true;
            this.rb_WaveLine.CheckedChanged += new EventHandler(this.rb_WaveLine_CheckedChanged);
            this.groupBox1.Controls.Add(this.rb_ColumnLine);
            this.groupBox1.Controls.Add(this.rb_PointLine);
            this.groupBox1.Controls.Add(this.rb_PolyLine);
            this.groupBox1.Controls.Add(this.rb_WaveLine);
            this.groupBox1.Location = new Point(998, 11);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new Size(155, 170);
            this.groupBox1.TabIndex = 2;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "图标类型设置";
            this.rb_PointLine.AutoSize = true;
            this.rb_PointLine.Location = new Point(44, 102);
            this.rb_PointLine.Name = "rb_PointLine";
            this.rb_PointLine.Size = new Size(59, 16);
            this.rb_PointLine.TabIndex = 2;
            this.rb_PointLine.TabStop = true;
            this.rb_PointLine.Text = "点形图";
            this.rb_PointLine.UseVisualStyleBackColor = true;
            this.rb_PointLine.CheckedChanged += new EventHandler(this.rb_PointLine_CheckedChanged);
            this.groupBox2.Controls.Add(this.bt_Redefine);
            this.groupBox2.Controls.Add(this.tb_Y_interval);
            this.groupBox2.Controls.Add(this.tb_Y_maximum);
            this.groupBox2.Controls.Add(this.tb_Y_minimum);
            this.groupBox2.Controls.Add(this.tb_X_interval);
            this.groupBox2.Controls.Add(this.tb_X_maximum);
            this.groupBox2.Controls.Add(this.tb_X_minimum);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new Point(998, 203);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new Size(155, 333);
            this.groupBox2.TabIndex = 3;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "绘图区设置";
            this.bt_Redefine.Location = new Point(22, 275);
            this.bt_Redefine.Name = "bt_Redefine";
            this.bt_Redefine.Size = new Size(112, 39);
            this.bt_Redefine.TabIndex = 2;
            this.bt_Redefine.Text = "修改";
            this.bt_Redefine.UseVisualStyleBackColor = true;
            this.bt_Redefine.Click += new EventHandler(this.bt_Redefine_Click);
            this.tb_Y_interval.Location = new Point(85, 223);
            this.tb_Y_interval.Name = "tb_Y_interval";
            this.tb_Y_interval.Size = new Size(57, 21);
            this.tb_Y_interval.TabIndex = 1;
            this.tb_Y_maximum.Location = new Point(85, 187);
            this.tb_Y_maximum.Name = "tb_Y_maximum";
            this.tb_Y_maximum.Size = new Size(57, 21);
            this.tb_Y_maximum.TabIndex = 1;
            this.tb_Y_maximum.KeyPress += new KeyPressEventHandler(this.textBox1_KeyPress);
            this.tb_Y_minimum.Location = new Point(85, 151);
            this.tb_Y_minimum.Name = "tb_Y_minimum";
            this.tb_Y_minimum.Size = new Size(57, 21);
            this.tb_Y_minimum.TabIndex = 1;
            this.tb_Y_minimum.KeyPress += new KeyPressEventHandler(this.textBox1_KeyPress);
            this.tb_X_interval.Location = new Point(85, 106);
            this.tb_X_interval.Name = "tb_X_interval";
            this.tb_X_interval.Size = new Size(57, 21);
            this.tb_X_interval.TabIndex = 1;
            this.tb_X_interval.KeyPress += new KeyPressEventHandler(this.textBox1_KeyPress);
            this.tb_X_maximum.Location = new Point(85, 69);
            this.tb_X_maximum.Name = "tb_X_maximum";
            this.tb_X_maximum.Size = new Size(57, 21);
            this.tb_X_maximum.TabIndex = 1;
            this.tb_X_maximum.KeyPress += new KeyPressEventHandler(this.textBox1_KeyPress);
            this.tb_X_minimum.Location = new Point(85, 33);
            this.tb_X_minimum.Name = "tb_X_minimum";
            this.tb_X_minimum.Size = new Size(57, 21);
            this.tb_X_minimum.TabIndex = 1;
            this.tb_X_minimum.KeyPress += new KeyPressEventHandler(this.textBox1_KeyPress);
            this.label6.AutoSize = true;
            this.label6.Location = new Point(7, 228);
            this.label6.Name = "label6";
            this.label6.Size = new Size(53, 12);
            this.label6.TabIndex = 0;
            this.label6.Text = "Y轴间距:";
            this.label5.AutoSize = true;
            this.label5.Location = new Point(7, 192);
            this.label5.Name = "label5";
            this.label5.Size = new Size(65, 12);
            this.label5.TabIndex = 0;
            this.label5.Text = "Y轴最大值:";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(7, 156);
            this.label4.Name = "label4";
            this.label4.Size = new Size(65, 12);
            this.label4.TabIndex = 0;
            this.label4.Text = "Y轴最小值:";
            this.label3.AutoSize = true;
            this.label3.Location = new Point(7, 110);
            this.label3.Name = "label3";
            this.label3.Size = new Size(53, 12);
            this.label3.TabIndex = 0;
            this.label3.Text = "X轴间距:";
            this.label2.AutoSize = true;
            this.label2.Location = new Point(7, 74);
            this.label2.Name = "label2";
            this.label2.Size = new Size(65, 12);
            this.label2.TabIndex = 0;
            this.label2.Text = "X轴最大值:";
            this.label1.AutoSize = true;
            this.label1.Location = new Point(7, 38);
            this.label1.Name = "label1";
            this.label1.Size = new Size(65, 12);
            this.label1.TabIndex = 0;
            this.label1.Text = "X轴最小值:";
            this.rb_ColumnLine.AutoSize = true;
            this.rb_ColumnLine.Location = new Point(44, 136);
            this.rb_ColumnLine.Name = "rb_ColumnLine";
            this.rb_ColumnLine.Size = new Size(59, 16);
            this.rb_ColumnLine.TabIndex = 3;
            this.rb_ColumnLine.TabStop = true;
            this.rb_ColumnLine.Text = "柱形图";
            this.rb_ColumnLine.UseVisualStyleBackColor = true;
            this.rb_ColumnLine.CheckedChanged += new EventHandler(this.rb_ColumnLine_CheckedChanged);
            this.label7.AutoSize = true;
            this.label7.Location = new Point(886, 430);
            this.label7.Name = "label7";
            this.label7.Size = new Size(35, 12);
            this.label7.TabIndex = 4;
            this.label7.Text = "状态:";
            this.pb_draw_status.BackColor = Color.Gray;
            this.pb_draw_status.BorderStyle = BorderStyle.Fixed3D;
            this.pb_draw_status.Location = new Point(927, 427);
            this.pb_draw_status.Name = "pb_draw_status";
            this.pb_draw_status.Size = new Size(40, 18);
            this.pb_draw_status.TabIndex = 5;
            this.pb_draw_status.TabStop = false;
            base.AutoScaleDimensions = new SizeF(6f, 12f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(1176, 584);
            base.Controls.Add(this.pb_draw_status);
            base.Controls.Add(this.label7);
            base.Controls.Add(this.groupBox2);
            base.Controls.Add(this.groupBox1);
            base.Controls.Add(this.chart1);
            base.FormBorderStyle = FormBorderStyle.FixedDialog;
            base.MaximizeBox = false;
            base.MinimizeBox = false;
            base.Name = "Graph";
            this.Text = "图形显示";
            base.FormClosing += new FormClosingEventHandler(this.Graph_FormClosing);
            base.Load += new EventHandler(this.Graph_Load);
            ((ISupportInitialize)this.chart1).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((ISupportInitialize)this.pb_draw_status).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

    }
}







